//------------------------------------------------------------------------------
// <auto-generated>
//     This code was auto-generated by com.unity.inputsystem:InputActionCodeGenerator
//     version 1.7.0
//     from Assets/KMS/Imputs/Camara.inputactions
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.InputSystem;
using UnityEngine.InputSystem.Utilities;

public partial class @Camara: IInputActionCollection2, IDisposable
{
    public InputActionAsset asset { get; }
    public @Camara()
    {
        asset = InputActionAsset.FromJson(@"{
    ""name"": ""Camara"",
    ""maps"": [
        {
            ""name"": ""CamaraActions"",
            ""id"": ""edd807bf-3d72-4b98-8725-26405230ac77"",
            ""actions"": [
                {
                    ""name"": ""MoveRight"",
                    ""type"": ""Button"",
                    ""id"": ""1166e5ac-6544-45ff-b846-a2e4e1218618"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""MoveLeft"",
                    ""type"": ""Button"",
                    ""id"": ""90cf578e-f1ac-4473-a814-e857452ff299"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""CamaraChange"",
                    ""type"": ""Button"",
                    ""id"": ""d3a13ccc-603b-4318-96f0-e6523cc8eed1"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                }
            ],
            ""bindings"": [
                {
                    ""name"": """",
                    ""id"": ""600bfebf-b79a-4b98-9a70-bcae7a3f4c17"",
                    ""path"": ""<Keyboard>/rightArrow"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MoveRight"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""3550960f-07b0-44fc-915b-e0f781126abb"",
                    ""path"": ""<Keyboard>/leftArrow"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MoveLeft"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""57fc5d7b-7b48-4087-b423-b37272948fe7"",
                    ""path"": ""<Keyboard>/e"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""CamaraChange"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                }
            ]
        }
    ],
    ""controlSchemes"": []
}");
        // CamaraActions
        m_CamaraActions = asset.FindActionMap("CamaraActions", throwIfNotFound: true);
        m_CamaraActions_MoveRight = m_CamaraActions.FindAction("MoveRight", throwIfNotFound: true);
        m_CamaraActions_MoveLeft = m_CamaraActions.FindAction("MoveLeft", throwIfNotFound: true);
        m_CamaraActions_CamaraChange = m_CamaraActions.FindAction("CamaraChange", throwIfNotFound: true);
    }

    public void Dispose()
    {
        UnityEngine.Object.Destroy(asset);
    }

    public InputBinding? bindingMask
    {
        get => asset.bindingMask;
        set => asset.bindingMask = value;
    }

    public ReadOnlyArray<InputDevice>? devices
    {
        get => asset.devices;
        set => asset.devices = value;
    }

    public ReadOnlyArray<InputControlScheme> controlSchemes => asset.controlSchemes;

    public bool Contains(InputAction action)
    {
        return asset.Contains(action);
    }

    public IEnumerator<InputAction> GetEnumerator()
    {
        return asset.GetEnumerator();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return GetEnumerator();
    }

    public void Enable()
    {
        asset.Enable();
    }

    public void Disable()
    {
        asset.Disable();
    }

    public IEnumerable<InputBinding> bindings => asset.bindings;

    public InputAction FindAction(string actionNameOrId, bool throwIfNotFound = false)
    {
        return asset.FindAction(actionNameOrId, throwIfNotFound);
    }

    public int FindBinding(InputBinding bindingMask, out InputAction action)
    {
        return asset.FindBinding(bindingMask, out action);
    }

    // CamaraActions
    private readonly InputActionMap m_CamaraActions;
    private List<ICamaraActionsActions> m_CamaraActionsActionsCallbackInterfaces = new List<ICamaraActionsActions>();
    private readonly InputAction m_CamaraActions_MoveRight;
    private readonly InputAction m_CamaraActions_MoveLeft;
    private readonly InputAction m_CamaraActions_CamaraChange;
    public struct CamaraActionsActions
    {
        private @Camara m_Wrapper;
        public CamaraActionsActions(@Camara wrapper) { m_Wrapper = wrapper; }
        public InputAction @MoveRight => m_Wrapper.m_CamaraActions_MoveRight;
        public InputAction @MoveLeft => m_Wrapper.m_CamaraActions_MoveLeft;
        public InputAction @CamaraChange => m_Wrapper.m_CamaraActions_CamaraChange;
        public InputActionMap Get() { return m_Wrapper.m_CamaraActions; }
        public void Enable() { Get().Enable(); }
        public void Disable() { Get().Disable(); }
        public bool enabled => Get().enabled;
        public static implicit operator InputActionMap(CamaraActionsActions set) { return set.Get(); }
        public void AddCallbacks(ICamaraActionsActions instance)
        {
            if (instance == null || m_Wrapper.m_CamaraActionsActionsCallbackInterfaces.Contains(instance)) return;
            m_Wrapper.m_CamaraActionsActionsCallbackInterfaces.Add(instance);
            @MoveRight.started += instance.OnMoveRight;
            @MoveRight.performed += instance.OnMoveRight;
            @MoveRight.canceled += instance.OnMoveRight;
            @MoveLeft.started += instance.OnMoveLeft;
            @MoveLeft.performed += instance.OnMoveLeft;
            @MoveLeft.canceled += instance.OnMoveLeft;
            @CamaraChange.started += instance.OnCamaraChange;
            @CamaraChange.performed += instance.OnCamaraChange;
            @CamaraChange.canceled += instance.OnCamaraChange;
        }

        private void UnregisterCallbacks(ICamaraActionsActions instance)
        {
            @MoveRight.started -= instance.OnMoveRight;
            @MoveRight.performed -= instance.OnMoveRight;
            @MoveRight.canceled -= instance.OnMoveRight;
            @MoveLeft.started -= instance.OnMoveLeft;
            @MoveLeft.performed -= instance.OnMoveLeft;
            @MoveLeft.canceled -= instance.OnMoveLeft;
            @CamaraChange.started -= instance.OnCamaraChange;
            @CamaraChange.performed -= instance.OnCamaraChange;
            @CamaraChange.canceled -= instance.OnCamaraChange;
        }

        public void RemoveCallbacks(ICamaraActionsActions instance)
        {
            if (m_Wrapper.m_CamaraActionsActionsCallbackInterfaces.Remove(instance))
                UnregisterCallbacks(instance);
        }

        public void SetCallbacks(ICamaraActionsActions instance)
        {
            foreach (var item in m_Wrapper.m_CamaraActionsActionsCallbackInterfaces)
                UnregisterCallbacks(item);
            m_Wrapper.m_CamaraActionsActionsCallbackInterfaces.Clear();
            AddCallbacks(instance);
        }
    }
    public CamaraActionsActions @CamaraActions => new CamaraActionsActions(this);
    public interface ICamaraActionsActions
    {
        void OnMoveRight(InputAction.CallbackContext context);
        void OnMoveLeft(InputAction.CallbackContext context);
        void OnCamaraChange(InputAction.CallbackContext context);
    }
}
